/// <reference types="react" />
import { BooleanStateType } from '@edtr-io/plugin';
import { DeepPartial } from '@edtr-io/ui';
import { EditorPlugin } from '@edtr-io/plugin';
import { EditorPluginProps } from '@edtr-io/plugin';
import { ObjectStateType } from '@edtr-io/plugin';
import * as React_2 from 'react';
import { StringStateType } from '@edtr-io/plugin';

/**
 * @param config - {@link HighlightConfig | Plugin configuration}
 * @public
 */
export declare function createHighlightPlugin(config?: HighlightConfig): EditorPlugin<HighlightPluginState, HighlightPluginConfig>;

/** @public */
export declare interface HighlightConfig {
    Renderer?: HighlightPluginConfig['Renderer'];
    i18n?: DeepPartial<HighlightPluginConfig['i18n']>;
}

/** @public */
export declare interface HighlightPluginConfig {
    Renderer: React_2.ComponentType<HighlightRendererProps>;
    i18n: {
        code: {
            label: string;
            placeholder: string;
        };
        language: {
            label: string;
            placeholder: string;
        };
        showLineNumbers: {
            label: string;
        };
    };
}

/** @public */
export declare type HighlightPluginState = ObjectStateType<{
    code: StringStateType;
    language: StringStateType;
    showLineNumbers: BooleanStateType;
}>;

/** @public */
export declare type HighlightProps = EditorPluginProps<HighlightPluginState, HighlightPluginConfig>;

/** @public */
export declare interface HighlightRendererProps {
    config: HighlightPluginConfig;
    code: string;
    language: string;
    showLineNumbers: boolean;
}

export { }
